<template lang="pug">
  .editor-toolbar(v-show="isShown" v-bind:style="stylesWithPx")
      template(v-if="showFlipButtons")
        .action.up.flip.flip-horizontal(
          v-tooltip="'Flip horizontally'"
          v-on:click="flipHorizontally"
        )
          .icon(v-html="$icons.flipHorizontal")
        .action.down.flip.flip-vertical(
          v-tooltip="'Flip vertically'"
          v-on:click="flipVertically"
        )
          .icon(v-html="$icons.flipVertical")
      template(v-if="showLayerButtons")
        .action.up(
          v-tooltip="'Move layer up'"
          v-on:click="moveUp"
        )
          .icon(v-html="$icons.up")

        .action.down(
          v-tooltip="'Move layer down'"
          v-on:click="moveDown"
        )
          .icon(v-html="$icons.down")

      .action.shadow(
        v-if="showShadowButton"
        v-on:click="toggleShadow()"
        v-bind:class="{ active: showShadow }"
        v-tooltip="'Switch shadow'"
      )
        .icon(v-html="$icons.shadow")

      .action.delete(
        v-tooltip="'Delete layer'"
        v-on:click="remove()"
      )
        .icon(v-html="$icons.bin")

</template>

<script>
import { mapState } from 'vuex'

import stageService from '../services/stage'
import itemsService from '../services/items/common'
import storeService from '../services/store'
import config from '../config'
import DeleteItemCommand from '../history/commands/deleteItem'
import ZIndexCommand from '../history/commands/zIndex'
import FlipImageCommand from '../history/commands/flipImage'
import HideShadowCommand from '../history/commands/hideShadow'
import RevealShadowCommand from '../history/commands/revealShadow'

export default {
  name: 'Toolbar',
  data () {
    return {
      TYPE_OBJECT: itemsService.TYPE_OBJECT,
      isShown: false,
      showFlipButtons: false,
      showLayerButtons: false,
      showShadow: false,
      showShadowButton: false,
      styles: {
        height: 0,
        top: 0,
        left: 0
      }
    }
  },
  computed: {
    ...mapState({
      activeItem: state => state.editor.activeItem,
      stylesWithPx () {
        return this.addPxToStyles(this.styles)
      }
    })
  },
  mounted () {
    document.addEventListener('mousedown', this.outsideClick)
  },
  destroyed () {
    document.removeEventListener('mousedown', this.outsideClick)
  },
  methods: {
    toggleShadow () {
      const activeItem = storeService.get('activeItem')
      const commandManager = storeService.get('commandManager')
      if (activeItem.findOne('.itemShadow').opacity()) {
        commandManager.execute(new HideShadowCommand(activeItem))
        this.showShadow = false
      } else {
        commandManager.execute(new RevealShadowCommand(activeItem))
        this.showShadow = true
      }
      this.calculatePosition()
    },
    addPxToStyles (styles) {
      let stylesWithPx = {}
      Object.keys(styles).forEach(style => {
        stylesWithPx[style] = styles[style] + 'px'
      })
      return stylesWithPx
    },
    degreeToRadian (degree) {
      return (degree / 180) * Math.PI
    },
    radianToDegree (radian) {
      return (radian / Math.PI) * 180
    },
    getHeight () {
      const activeItem = storeService.get('activeItem')
      const flipBtnHeight = config.stage.margin.left * 2 + 18
      let height = config.stage.margin.left + 16
      let itemsQuantity = 0
      if (activeItem.getAttrs().objectData.type !== itemsService.TYPE_TEXT) {
        height += flipBtnHeight
      }

      if (![itemsService.TYPE_BACKGROUND, itemsService.TYPE_UPLOAD_BACKGROUND].includes(activeItem.getAttrs().objectData.type)) {
        storeService.get('items').forEach(item => {
          if (
            item.getAttrs().objectData &&
            [
              itemsService.TYPE_OBJECT,
              itemsService.TYPE_MODEL,
              itemsService.TYPE_UPLOAD,
              itemsService.TYPE_TEXT
            ].includes(item.getAttrs().objectData.type)
          ) {
            itemsQuantity++
          }
        })
      }

      // Shadow button
      if (activeItem.getAttrs().objectData.shadowData) {
        height += config.stage.margin.left + 16
      }

      // Layer up/down buttons
      if (itemsQuantity > 1) {
        height += config.stage.margin.left * 2 + 2
      }

      return height
    },
    remove () {
      storeService
        .get('commandManager')
        .execute(new DeleteItemCommand(storeService.get('activeItem')))
    },
    moveUp () {
      const activeItem = storeService.get('activeItem')
      if (activeItem.getZIndex() < activeItem.parent.children.length - 1) {
        storeService
          .get('commandManager')
          .execute(new ZIndexCommand(activeItem, activeItem.getZIndex() + 1))
      }
    },
    moveDown () {
      const activeItem = storeService.get('activeItem')
      if (activeItem.getZIndex() > (storeService.get('background') ? 1 : 0)) {
        storeService
          .get('commandManager')
          .execute(new ZIndexCommand(activeItem, activeItem.getZIndex() - 1))
      }
    },
    flipVertically () {
      const activeItem = storeService.get('activeItem')
      const flipAxis = itemsService.FLIP_AXIS_VERTICAL
      storeService
        .get('commandManager')
        .execute(new FlipImageCommand(activeItem, flipAxis))
    },
    flipHorizontally () {
      const activeItem = storeService.get('activeItem')
      const flipAxis = itemsService.FLIP_AXIS_HORIZONTAL
      storeService
        .get('commandManager')
        .execute(new FlipImageCommand(activeItem, flipAxis))
    },
    show () {
      const activeItem = storeService.get('activeItem')
      let itemsCount = 0
      if (![itemsService.TYPE_BACKGROUND, itemsService.TYPE_UPLOAD_BACKGROUND].includes(activeItem.getAttrs().objectData.type)) {
        storeService.get('items').forEach(item => {
          if (
            item.getAttrs().objectData &&
            [
              itemsService.TYPE_OBJECT,
              itemsService.TYPE_MODEL,
              itemsService.TYPE_UPLOAD,
              itemsService.TYPE_TEXT
            ].includes(item.getAttrs().objectData.type)
          ) {
            itemsCount++
          }
        })
      }
      this.showFlipButtons = activeItem.getAttrs().objectData.type !== itemsService.TYPE_TEXT
      this.showLayerButtons = itemsCount > 1
      this.calculatePosition()

      // Handle shadow
      this.showShadowButton = false
      if (itemsService.SHADOWED_TYPES.includes(activeItem.getAttrs().objectData.type)) {
        const shadow = activeItem.findOne('.itemShadow')
        this.showShadowButton = !!shadow
        this.showShadow = shadow && !activeItem.getAttrs().objectData.ignoreShadow ? shadow.visible() : false
      }

      this.isShown = true
    },
    hide () {
      this.isShown = false
    },
    calculatePosition () {
      const item = storeService.get('activeItem')
      if (item) {
        const stage = storeService.get('stage')
        const itemWidth = item.width() * Math.abs(item.scaleX())
        const itemHeight = item.height() * Math.abs(item.scaleY())
        const rotation = stageService.calculateRotationAngle(item.rotation())
        const angleCorrection = rotation / 90
        const startingAngle = Math.atan(itemHeight / itemWidth)
        const radius = Math.sqrt(Math.pow(itemWidth, 2) + Math.pow(itemHeight, 2)) / 2
        let angleTotal = this.degreeToRadian(rotation) - startingAngle
        let topCorrection = 0

        // Calculate rotation corrections
        if (rotation > 0 && rotation <= 90) {
          topCorrection = angleCorrection * itemWidth
        } else if (rotation > 90 && rotation <= 180) {
          angleTotal -= this.degreeToRadian(180) - startingAngle * 2
          topCorrection = (angleCorrection - 1) * itemHeight
        } else if (rotation > 180 && rotation <= 270) {
          angleTotal += this.degreeToRadian(180)
          topCorrection = (angleCorrection - 2) * itemWidth
        } else if (rotation > 270 && rotation <= 360) {
          angleTotal += startingAngle * 2
          topCorrection = (angleCorrection - 3) * itemHeight
        }

        // Calculate coordinates, they should be placed in the center of item
        const itemX = item.x()
        const itemY = item.y()

        let left = itemX + radius * Math.cos(angleTotal) + 16
        let top = itemY + radius * Math.sin(angleTotal) - topCorrection

        // Calculate height of toolbar
        const stageMargin = config.stage.margin.left
        const toolbarHeight = this.getHeight()
        if (rotation === 0) {
          if (itemHeight > toolbarHeight) {
            top = itemY - itemHeight / 2 + (itemHeight - toolbarHeight) / 2
          } else {
            top = itemY - itemHeight / 2
          }
        }

        // If toolbar is outside the upper rim - recalculate Y position
        if (top < 0) {
          top = 0
        }

        // If item is outside the bottom rim - recalculate Y position
        if (top + toolbarHeight > stage.height()) {
          top = stage.height() - toolbarHeight
        }

        // Prevent toolbar from positioning outside the right rim
        if (left + stageMargin > stage.width()) {
          left = stage.width() - stageMargin
        }

        this.styles.height = toolbarHeight
        this.styles.top = top
        this.styles.left =
          left +
          (item.getAttrs().objectData.type === itemsService.TYPE_TEXT ? 5 : 0)
      }
    }
  }
}
</script>

<style lang="scss" scoped>
@import "../assets/css/mixins";
@import "../assets/css/variables";

.editor-toolbar {
  width: 36px;
  position: absolute;
  display: flex;
  flex-direction: column;
  z-index: 20;

  .action {
    width: 36px;
    height: 36px;
    background-color: $toolbar-background-color;
    display: flex;
    align-items: center;
    justify-content: center;
    border-radius: 36px;
    cursor: pointer;

    &.up:hover,
    &.down:hover {
      background-color: #6b6b6b;
      @include delay();
    }

    &.up {
      border-radius: 36px 36px 0 0;
    }

    &.down {
      border-radius: 0 0 36px 36px;
      margin-top: 2px;
      &.flip {
        margin-bottom: 18px;
      }
    }

    &.flip-horizontal {
      .icon {
        width: 18px;
        height: 17px;
      }
    }

    &.flip-vertical {
      .icon {
        width: 13px;
        height: 18px;
      }
    }

    &.shadow {
      margin-top: 16px;

      &.active {
        background-color: #fff;

        .icon {
          fill: #000;
        }
      }

      .icon {
        width: 14px;
        height: 18px;
      }
    }

    &.delete {
      background-color: #ff5659;
      margin-top: 16px;

      &:hover {
        background-color: red;
        @include delay();
      }
    }

    .icon {
      width: 10px;
      height: 17px;
      fill: #fff;
    }
  }
}
</style>
